=begin
  $Id: test.rb,v 1.1 2000/10/23 13:47:21 feldt Exp $

  Unit test for XX.

  Part of Yoda (Yet another jOb Distributing And queueing system).
  (c) Copyright 2000, Robert Feldt, feldt@ce.chalmers.se

  This software is distributed under a license. See LICENSE in the Yoda main 
  directory for more information.

=end
require 'runit/testcase'
require 'runit/testsuite'
require 'runit/cui/testrunner'
require 'bitvector_extras'

class Test_BitVector < RUNIT::TestCase

  def setup
    @i1 = BitVector.new(20, "11111111111111111111")
    @i2 = BitVector.new(20, "00000000000000000000")
  end

  def test_01_crossover_1point
    c1, c2 = @i1.crossover_1point(@i2, 10)
    assert_equals(20, c1.length)
    assert_equals(20, c2.length)
    assert_equals("11111111110000000000", c2.inspect)
    assert_equals("00000000001111111111", c1.inspect)
    assert_equals("11111111111111111111", @i1.inspect)
    assert_equals("00000000000000000000", @i2.inspect)

    c1, c2 = @i1.crossover_1point(@i2, 19)
    assert_equals(20, c1.length)
    assert_equals(20, c2.length)
    assert_equals("10000000000000000000", c2.inspect)
    assert_equals("01111111111111111111", c1.inspect)
  end

  def test_02_crossover_2point
    c1, c2 = @i1.crossover_2point(@i2, 5, 12)
    assert_equals(20, c1.length)
    assert_equals(20, c2.length)
    assert_equals("00000000111111100000", c2.inspect)
    assert_equals("11111111000000011111", c1.inspect)
  end
end

# Run if we were directly called
if $0 == __FILE__
  testrunner = RUNIT::CUI::TestRunner.new
  if ARGV.size == 0
    suite = Test_BitVector.suite
  else
    suite = RUNIT::TestSuite.new
    ARGV.each do |testmethod|
      suite.add_test(Test_BitVector.new(testmethod))
    end
  end
  testrunner.run(suite)
end



